#!/usr/bin/perl

use CGI;
use Data::Dumper;
use Digest::MD5 qw(md5 md5_hex md5_base64);
use Log::Log4perl qw(:easy);
use CGI::Carp qw(fatalsToBrowser set_message warningsToBrowser);


use strict;
use vars qw($logger);

$| = 1;
my $q      = new CGI;
warningsToBrowser(1);

# Init logger
Log::Log4perl->init("conf/logger.conf");
$logger = get_logger();

sub convert_document {
    my ($id,$file) = @_;

    my $rc = 1;
    system("mkdir tmp/$id");
    print "<pre>";
    if (-e "tmp/$id/index.html") {
        print "Already converted....\n";
    }
    else {
        my @commands;
        
        if ($file =~ /\.xls$/) {
            $commands[0] = "xlhtml -c '$file' > 'tmp/$id/index.html' 2>/tmp/error.log";
        }
        elsif ($file =~ /\.ppt$/) {
            $commands[0] = "ppthtml '$file' > 'tmp/$id/index.html' 2>/tmp/error.log";
        }
        elsif ($file =~ /\.doc$/) {
            $commands[0] = "wvHtml '$file' 'tmp/$id/index.html' 2>/tmp/error.log";
        }
        elsif ($file =~ /\.pdf$/) {
            $commands[0] = "pdf2swf '$file' -o 'tmp/$id/doc.swf'";
            $commands[1] = "cp flashviewer/flexpaper/template.html tmp/$id/index.html; cat tmp/$id/index.html | sed -e 's/ID/$id/g' > a;mv a tmp/$id/index.html";
            $commands[2] = "/usr/bin/pdftohtml -zoom 1.5 -c '$file' 'tmp/$id/html'";
        }
        elsif ($file =~/\.rtf$/) {
            $commands[0] = "unrtf --html $file > 'tmp/$id/index.html' 2>/tmp/error.log";
        }
       elsif ($file =~/\.url$/) {
            my $url = `cat '$file'`;
            print qq{<iframe frameborder="0" scrolling="no" style="border:0px" src="$url&lpg=PP1&pg=PP1&output=embed" width=100% height=100%></iframe>};
            #redirect_url($url);
            return;
        }

       else {
            die "Unsupported doc type for file $file!";
       }
        print "Coverting file $file (id = $id).....<br>";

        foreach my $command (@commands) {
            print "Running command $command\n";
            $rc = system($command);
        }
    }
    print "</pre>";
    redirect_url("tmp/$id") if (-e "tmp/$id/index.html");

}

sub convert_mindmap {

    my($file) = @_;

    $file =~s/\.mmap/%2Emmap/g;
    
    my $viewer_url = "http://eric-blue.com/projects//mindmapviewer/display.cgi?mmap_url=" . $file . "&format=flash";
    redirect_url($viewer_url);

}

sub redirect_url {
    my ($url) = @_;

    print qq{<script>document.location.href='$url';</script>}
}

print $q->header();
my $docurl = $q->param('docurl');

if ($docurl =~/\.mmap$/) {
    print "Converting mindmap.....<br>";
    convert_mindmap($docurl);
}
if ($docurl =~/\.txt$|\.htm$|\.html$|\.jpg$|\.gif$/) {
    redirect_url($docurl);
}
else {
    my $base_url = "http://eric-blue.com/projects/docbrowser/docs/";
    $docurl =~ s/$base_url//g;
    my $file = "/var/www/domains/eric-blue.com/docs/projects/docbrowser/docs" . $docurl;
    my $docid = md5_base64($file);
    $docid=~s/\//0/g;
    $docid=~s/\+/0/g;
    convert_document($docid,$file);
}

